
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>dump命令1——ITL文件dump / iVAN</title>

    <meta name="description" content="dump命令1——ITL文件dump 本文转自:http://space.itpub.net/17203031/viewspace-716353 关于ITL事务槽的定义,参考我的博客:http://blog.csdn.net/changyanmanman/article/details/7081699 http://blog.csdn.net/changyanmanman/article/details/7312988 在Oracle中,数据块block上存在记录事务信息的ITL(Interest Transaction List)">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">dump命令1——ITL文件dump</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文转自：<a href="http://space.itpub.net/17203031/viewspace-716353" rel="external nofollow noreferrer">http://space.itpub.net/17203031/viewspace-716353</a></p>
<p>关于ITL事务槽的定义，参考我的博客：<a href="http://blog.csdn.net/changyanmanman/article/details/7081699" rel="external nofollow noreferrer">http://blog.csdn.net/changyanmanman/article/details/7081699</a></p>
<p><a href="http://blog.csdn.net/changyanmanman/article/details/7312988" rel="external nofollow noreferrer">http://blog.csdn.net/changyanmanman/article/details/7312988</a></p>
<p>在Oracle中，数据块<a href="http://space.itpub.net/17203031/viewspace-716353" rel="external nofollow noreferrer"><u><strong>block</strong></u></a>上存在记录事务信息的<a href="http://space.itpub.net/17203031/viewspace-716353" rel="external nofollow noreferrer"><u><strong>ITL</strong></u></a>（Interest<br />
 Transaction List）。当一个<a href="http://space.itpub.net/17203031/viewspace-716353" rel="external nofollow noreferrer"><u><strong>数据库</strong></u></a>事务涉及到数据块对应的数据时，就会在当前数据块块头（block head）后面的ITL中记录上相应的信息。</p>
<p>本篇从数据块逻辑结构角度入手，分析ITL中所包括的内容和与事务对应的信息。</p>
<p> </p>
<p><strong>1、环境准备</strong></p>
<p> </p>
<p>在这里，我们准备一个简单的数据表作为<a href="http://space.itpub.net/17203031/viewspace-716353" rel="external nofollow noreferrer"><u><strong>实验</strong></u></a>对象。</p>
<p>SQL&gt; select * from v$version;</p>
<p>BANNER</p>
<p>----------------------------------------------------------------</p>
<p>Oracle Database <a href="http://space.itpub.net/17203031/viewspace-716353" rel="external nofollow noreferrer"><u><strong>10g</strong></u></a> Enterprise Edition Release 10.2.0.1.0 - Prod</p>
<p>PL/SQL Release 10.2.0.1.0 - Production</p>
<p>CORE   10.2.0.1.0   Production</p>
<p>TNS for 32-bit Windows: Version 10.2.0.1.0 - Production</p>
<p>NLSRTL Version 10.2.0.1.0 - Production</p>
<p>SQL&gt; create <a href="http://space.itpub.net/17203031/viewspace-716353" rel="external nofollow noreferrer"><u><strong>table</strong></u></a> t2 (id number, vname varchar2(10));</p>
<p>Table created</p>
<p>SQL&gt; insert into t2 values (1, 'id');</p>
<p>1 row inserted</p>
<p>SQL&gt; insert into t2 values (2, 'iddf');</p>
<p>1 row inserted</p>
<p>SQL&gt; commit;</p>
<p>Commit complete</p>
<p> </p>
<p> </p>
<p>此时，对应的数据段信息如下：</p>
<p>SQL&gt; select HEADER_FILE, HEADER_BLOCK, BYTES, BLOCKS, EXTENTS from dba_segments where owner='SYS' and segment_name='T2';</p>
<p> </p>
<p>HEADER_FILE      HEADER_BLOCK       BYTES        BLOCKS    EXTENTS<br />
-----------                        ------------                ----------          ----------        ----------<br />
          4                              563                       65536               8                   1</p>
<p> </p>
<p>从数据字典信息看，Oracle为该数据段T分配了一个extents分区，其中包括8个数据块。</p>
<p> </p>
<p><strong>2、无事务状态下的ITL事务槽</strong></p>
<p>首先，我们需要知道各个数据行对应的物理位置。我们可以使用dbms_rowid的包方法解析数据行rowid信息。Rowid中实际包括几个组成部分：相对文件编号、对象编号、数据块号和行slot号。</p>
<p>SQL&gt; select id,dbms_rowid.rowid_relative_fno(rowid) fno,dbms_rowid.rowid_block_n<br />
umber(rowid) bno,dbms_rowid.rowid_row_number(rowid) row_num from t2;</p>
<p>        ID        FNO        BNO    ROW_NUM<br />
---------- ----------   ----------     ----------<br />
         1          4          566            0<br />
         2          4          566            1</p>
<p> </p>
<p> </p>
<p>两个数据行均在文件4的566数据块上。我们接下来使用<a href="http://space.itpub.net/17203031/viewspace-716353" rel="external nofollow noreferrer"><u><strong>dump</strong></u></a>数据块的方法，将该块的逻辑结构dump到当前会话对应的跟踪文件中。 </p>
<p>SQL&gt; alter system dump datafile 4 block 566;</p>
<p>System altered</p>
<p>--获取trace跟踪文件位置名称</p>
<p>SQL&gt;  select f_get_trace_name from dual;</p>
<p>F_GET_TRACE_NAME<br />
---------------------------------------------------------------------</p>
<p>D:\ORACLE\PRODUCT\10.1.0\ADMIN\ORCL\UDUMP\orcl_ora_3736.trc</p>
<p> 这个f_get_trace_name是一个函数，其代码如下（注意此函数只能在sys用户下完成创建）：</p>
<p>create or replace function F_GET_TRACE_NAME return varchar2 is<br />
  Result varchar2(1000);<br />
begin<br />
  SELECT    d.VALUE<br />
       || '\'<br />
       || LOWER (RTRIM (i.INSTANCE, CHR (0)))<br />
       || '_ora_'<br />
       || p.spid<br />
       || '.trc' trace_file_name<br />
  into result<br />
  FROM (SELECT p.spid<br />
          FROM v$mystat m, v$session s, v$process p<br />
         WHERE m.statistic# = 1 AND s.SID = m.SID AND p.addr = s.paddr) p,<br />
       (SELECT t.INSTANCE<br />
          FROM v$thread t, v$parameter v<br />
         WHERE v.NAME = 'thread'<br />
           AND (v.VALUE = 0 OR t.thread# = TO_NUMBER (v.VALUE))) i,<br />
       (SELECT VALUE<br />
          FROM v$parameter<br />
         WHERE NAME = 'user_dump_dest') d;<br />
  return(Result);<br />
end F_GET_TRACE_NAME;</p>
<p>我们打开跟踪文件，可以找到对应的itl信息片段：</p>
<p>*** 2012-09-15 10:29:13.984<br />
Start dump data blocks tsn: 4 file#: 4 minblk 566 maxblk 566<br />
buffer tsn: 4 rdba: 0x01000236 (4/566)<br />
scn: 0x0000.00a480fc seq: 0x01 flg: 0x00 tail: 0x80fc0601<br />
frmt: 0x02 chkval: 0x0000 type: 0x06=trans data<br />
Block header dump:  0x01000236<br />
 Object id on Block? Y<br />
 seg/obj: 0xe357  csc: 0x00.a47f64  itc: 2  flg: E  typ: 1 - DATA<br />
     brn: 0  bdba: 0x1000231 ver: 0x01 opc: 0<br />
     inc: 0  exflg: 0<br />
 <br /> Itl           Xid                                                 Uba                           Flag       Lck                                           Scn/Fsc<br />
0x01   0x0004.021.000039df       0x0080078c.1916.18        --U-         1                              fsc 0x0000.00a47f7b<br />
0x02   0x0004.018.000039e0     0x0080078f.1916.0c          ----           1                              fsc 0x0000.00000000<br />
 <br />
data_block_dump,data header at 0x41d0264<br />
===============<br />
tsiz: 0x1f98<br />
hsiz: 0x16<br />
pbl: 0x041d0264<br />
bdba: 0x01000236<br />
     76543210<br />
flag=--------<br />
ntab=1<br />
nrow=2<br />
frre=-1<br />
fsbo=0x16<br />
fseo=0x1f84<br />
avsp=0x1f6e<br />
tosp=0x1f6e<br />
0xe:pti[0] nrow=2offs=0<br />
0x12:pri[0] offs=0x1f8f<br />
0x14:pri[1] offs=0x1f84<br />
block_row_dump:<br />
tab 0, row 0, @0x1f8f<br />
tl: 9 fb: --H-FL-- lb: 0x1  cc: 2<br />
col  0: [ 2]  c1 02<br />
col  1: [ 2]  69 64<br />
tab 0, row 1, @0x1f84<br />
tl: 11 fb: --H-FL-- lb: 0x2  cc: 2<br />
col  0: [ 2]  c1 03<br />
col  1: [ 4]  69 64 64 66<br />
end_of_block_dump<br />
End dump data blocks tsn: 4 file#: 4 minblk 566 maxblk 566</p>
<p> </p>
<p>对每一个数据块，都是包括ITL列表，用于描述当前数据块上进行的事务信息。在创建数据段对象的时候，包括initrans参数（默认值为1），就是表示该数据表对象的数据块创建时候初始ITL事务槽的个数。Initrans参数在10g之后，基本上就失去了其效果的场景。Oracle对数据块，初始都是创建两个事务槽对象。当并发事务操作较多的时候，会进行自动的拓展，拓展到最大值255。</p>
<p>从上面的片段，我们可以看到该数据块中，有两个itl事务槽。Itl列表示连接的事务槽编号。</p>
<p>Xid是由三列使用十六进制编码的数字列表示，该列表示对应的事务编号。在Oracle中，标识一个事务是通过 <strong>usn.slot.sqn </strong>表示。事务槽起作用的时候，每一个事务槽都与一个事务相关联。</p>
<p> </p>
<p>Uba应当为undo block address的缩写。多版本一致读是Oracle保证读操作不会被事务阻塞的重要特性。当<a href="http://space.itpub.net/17203031/viewspace-716353" rel="external nofollow noreferrer"><u><strong>Server</strong></u></a> Process需要查询一个正在被事务修改，但是尚未提交的数据时，就根据ITL上的uba定位到对应Undo前镜像数据位置。</p>
<p> </p>
<p>Flag对应的是当前事务槽的状态信息，标志着不同的事务状态（下表信息引自网络资料）。</p>
<p> </p>
<table>
<tbody>
<tr>
<td>
<br /><strong>Flag取值</strong></p>
</td>
<td>
<br /><strong>含义</strong></p>
</td>
</tr>
<tr>
<td>
<br />-----  </p>
</td>
<td>
<br />事务是活动的，或者在块清除前提交事务</p>
</td>
</tr>
<tr>
<td>
<br />C---</p>
</td>
<td>
<br />事务已经提交并且清除了行锁定</p>
</td>
</tr>
<tr>
<td>
<br />-B--</p>
</td>
<td>
<br />this undo record contains the undo for this ITL entry</p>
</td>
</tr>
<tr>
<td>
<br />--U-</p>
</td>
<td>
<br />事务已经提交（SCN已经是最大值），但是锁定还没有清除（快速清除）</p>
</td>
</tr>
<tr>
<td>
<br />---T</p>
</td>
<td>
<br />当块清除的SCN被记录时，该事务仍然是活动的，块上如果有已经提交的事务，那么在clean ount的时候，块会被进行清除，但是这个块里面的事务不会被清除。</p>
</td>
</tr>
<tr>
<td>
<br /> </p>
</td>
<td>
<br /> </p>
</td>
</tr>
</tbody>
</table>
<p> </p>
<p>Lck表示该事务槽涉及到的记录数目。<strong>Scn/Fsc：表示快速提交和已经提交的SCN编号。</strong></p>
<p> </p>
<p>从上面的ITL片段表示两条记录对应的事务已经提交，并且对应最大的SCN取值。</p>
<p> </p>
<p><strong>3、启动单会话事务</strong></p>
<p> </p>
<p>我们首先观察一下，当启动一个会话事务的时候，ITL状态情况。</p>
<p>SQL&gt; select sid from v$mystat where rownum&lt;2;</p>
<p>      SID</p>
<p>----------</p>
<p>      162</p>
<p> </p>
<p>SQL&gt; update t2 set vname='d' where id=1;</p>
<p>1 row updated</p>
<p> </p>
<p>此时，对应事务信息为。</p>
<p>SQL&gt; select addr,xidusn,xidslot,xidsqn from v$transaction;</p>
<p>ADDR                 XIDUSN    XIDSLOT     XIDSQN<br />
--------                ----------         ----------        ----------<br />
6C278F2C           4                  26              14820</p>
<p> </p>
<p> </p>
<p>这时候，我们尝试dump出数据块：</p>
<p>SQL&gt; alter system dump datafile 4 block 566;<br />
系统已更改。</p>
<p>情况如下：</p>
<p>Dump file d:\oracle\product\10.1.0\admin\orcl\udump\orcl_ora_7692.trc<br />
Sat Sep 15 11:13:33 2012<br />
ORACLE V10.1.0.2.0 - Production vsnsta=0<br />
vsnsql=13 vsnxtr=3<br />
Oracle Database 10g Enterprise Edition Release 10.1.0.2.0 - Production<br />
With the Partitioning, OLAP and Data Mining options<br />
Windows XP Version V5.1 Service Pack 3<br />
CPU             : 2 - type 586, 2 Physical Cores<br />
Process Affinity: 0x00000000<br />
Memory (A/P)    : PH:772M/2042M, PG:1903M/3935M, VA:1733M/2047M<br />
Instance name: orcl<br />
Redo thread mounted by this instance: 1</p>
<p>Oracle process number: 12</p>
<p>Windows thread id: 7692, image: ORACLE.EXE (SHAD)</p>
<p>*** 2012-09-15 11:13:33.078<br />
*** ACTION NAME:() 2012-09-15 11:13:33.015<br />
*** MODULE NAME:(SQL*Plus) 2012-09-15 11:13:33.015<br />
*** SERVICE NAME:(SYS$USERS) 2012-09-15 11:13:33.015<br />
*** SESSION ID:(162.13) 2012-09-15 11:13:33.015<br />
Start dump data blocks tsn: 4 file#: 4 minblk 566 maxblk 566<br />
buffer tsn: 4 rdba: 0x01000236 (4/566)<br />
scn: 0x0000.00a48c9b seq: 0x01 flg: 0x04 tail: 0x8c9b0601<br />
frmt: 0x02 chkval: 0x7b0c type: 0x06=trans data<br />
Block header dump:  0x01000236<br />
 Object id on Block? Y<br />
 seg/obj: 0xe357  csc: 0x00.a48c78  itc: 2  flg: E  typ: 1 - DATA<br />
     brn: 0  bdba: 0x1000231 ver: 0x01 opc: 0<br />
     inc: 0  exflg: 0<br />
 <br />
 Itl                            Xid                                       Uba                        Flag            Lck              Scn/Fsc<br />
0x01   0x0004.010.000039e4         0x008007a3.1916.22       C---               0         scn 0x0000.00a48c5d<br />
0x02   0x0004.01a.000039e4         0x008007a3.1916.29        ----               1          fsc 0x0000.00000000<br />
 <br />
data_block_dump,data header at 0x40e0264<br />
===============<br />
tsiz: 0x1f98<br />
hsiz: 0x16<br />
pbl: 0x040e0264<br />
bdba: 0x01000236<br />
     76543210<br />
flag=--------<br />
ntab=1<br />
nrow=2<br />
frre=-1<br />
fsbo=0x16<br />
fseo=0x1f7c<br />
avsp=0x1f6e<br />
tosp=0x1f6e<br />
0xe:pti[0] nrow=2offs=0<br />
0x12:pri[0] offs=0x1f7c<br />
0x14:pri[1] offs=0x1f84<br />
block_row_dump:<br />
tab 0, row 0, @0x1f7c<br />
tl: 8 fb: --H-FL-- lb: 0x2  cc: 2<br />
col  0: [ 2]  c1 02<br />
col  1: [ 1]  64<br />
tab 0, row 1, @0x1f84<br />
tl: 11 fb: --H-FL-- lb: 0x0  cc: 2<br />
col  0: [ 2]  c1 03<br />
col  1: [ 4]  69 64 64 66<br />
end_of_block_dump<br />
End dump data blocks tsn: 4 file#: 4 minblk 566 maxblk 566</p>
<p> </p>
<p>第二行事务槽，锁定影响记录数量为1。对应的xid为 0x0004.01a.000039e4  。分析下转换为十进制后分别为：4，26和14820。与v$transaction中对应的事务标识一致。说明0x02事务槽对应的是我们会话事务。</p>
<p> </p>
<p> </p>
<p><strong>4、启动第二个会话事务</strong></p>
<p>当我们启动第二个会话事务时，观察情况。 </p>
<p>SQL&gt; select sid from v$mystat where rownum&lt;2;</p>
<p>      SID</p>
<p>----------</p>
<p>      151</p>
<p> </p>
<p>SQL&gt; update t2 set vname='fk' where id=2;</p>
<p>1 row updated</p>
<p> </p>
<p> </p>
<p>事务信息和锁信息如下：</p>
<p>SQL&gt; select addr,xidusn,xidslot,xidsqn from v$transaction;</p>
<p>ADDR               XIDUSN    XIDSLOT     XIDSQN<br />
--------             ----------       ----------       ----------<br />
6C2A1314          5               34            3361</p>
<p> </p>
<p>SQL&gt; select addr, kaddr, sid, type, id1, id2, lmode from v$lock where sid=151 or sid=162 order by sid;</p>
<p> </p>
<p>ADDR                   KADDR           SID        TY        ID1            ID2              LMODE<br />
--------                 --------              ----------     --        ----------        ----------   ----------<br />6C2A1314      6C2A1428        151         TX      327716       3361            6<br />
6C237F30      6C237F48        151         TM       58199          0                3<br />
6C278F2C     6C279040        162         TX      262152      14821          6<br />
6C237E9C    6C237EB4        162         TM       58199          0                3</p>
<p>两个事务同时作用在相同的数据块上。我们dump出数据块查看ITL。</p>
<p> *** 2012-09-15 11:38:06.921<br />
*** ACTION NAME:() 2012-09-15 11:38:06.875<br />
*** MODULE NAME:(SQL*Plus) 2012-09-15 11:38:06.875<br />
*** SERVICE NAME:(SYS$USERS) 2012-09-15 11:38:06.875<br />
*** SESSION ID:(151.12329) 2012-09-15 11:38:06.875<br />
Start dump data blocks tsn: 4 file#: 4 minblk 566 maxblk 566<br />
buffer tsn: 4 rdba: 0x01000236 (4/566)<br />
scn: 0x0000.00a48fa4 seq: 0x01 flg: 0x04 tail: 0x8fa40601<br />
frmt: 0x02 chkval: 0xfd0b type: 0x06=trans data<br />
Block header dump:  0x01000236<br />
 Object id on Block? Y<br />
 seg/obj: 0xe357  csc: 0x00.a48f48  itc: 2  flg: E  typ: 1 - DATA<br />
     brn: 0  bdba: 0x1000231 ver: 0x01 opc: 0<br />
     inc: 0  exflg: 0<br />
 <br />
 Itl           Xid                  Uba         Flag  Lck        Scn/Fsc<br />
0x01   0x0005.024.00000d21  0x00800017.09f1.19  ----    1  fsc 0x0000.00000000<br />
0x02   0x0004.008.000039e5  0x008007a6.1916.0d  ----    1  fsc 0x0000.00000000</p>
<p>data_block_dump,data header at 0x65a0264<br />
===============<br />
tsiz: 0x1f98<br />
hsiz: 0x16<br />
pbl: 0x065a0264<br />
bdba: 0x01000236<br />
     76543210<br />
flag=--------<br />
ntab=1<br />
nrow=2<br />
frre=-1<br />
fsbo=0x16<br />
fseo=0x1f73<br />
avsp=0x1f70<br />
tosp=0x1f70<br />
0xe:pti[0] nrow=2offs=0<br />
0x12:pri[0] offs=0x1f7c<br />
0x14:pri[1] offs=0x1f73<br />
block_row_dump:<br />
tab 0, row 0, @0x1f7c<br />
tl: 8 fb: --H-FL-- lb: 0x2  cc: 2<br />
col  0: [ 2]  c1 02<br />
col  1: [ 1]  64<br />
tab 0, row 1, @0x1f73<br />
tl: 9 fb: --H-FL-- lb: 0x1  cc: 2<br />
col  0: [ 2]  c1 03<br />
col  1: [ 2]  66 6b<br />
end_of_block_dump<br />
End dump data blocks tsn: 4 file#: 4 minblk 566 maxblk 566</p>
<p> </p>
<p>两条ITL被占据。</p>
<p> </p>
<p><strong>5、第三个会话事务开启</strong></p>
<p> </p>
<p>当我们启动第三个会话事务，情况如何呢？</p>
<p>SQL&gt; select sid from v$mystat where rownum&lt;2;</p>
<p> </p>
<p>      SID</p>
<p>----------</p>
<p>      149 </p>
<p>SQL&gt; insert into t2 values (3,'kl');</p>
<p>1 row inserted</p>
<p> </p>
<p>锁定情况如下：</p>
<p>SQL&gt; select addr, kaddr, sid, type, id1, id2, lmode from v$lock where sid=149 or sid=151 or sid=162 order by sid;</p>
<p> </p>
<p>ADDR                KADDR           SID        TY        ID1          ID2         LMODE<br />
--------                --------               ---------- -- ----------        ----------     ----------<br />
6C27349C     6C2735B0       149      TX     393221       2958           6<br />
6C238058      6C238070       149      TM      58199          0               3<br />
6C2A1314     6C2A1428        151      TX     327716       3361          6<br />
6C237F30     6C237F48        151     TM      58199          0                3<br />
6C278F2C    6C279040        162      TX     262152      14821         6<br />
6C237E9C    6C237EB4       162     TM      58199          0                3<br />
已选择6行。</p>
<p> </p>
<p> </p>
<p>--对应v$transaction情况；</p>
<p> </p>
<p>SQL&gt;  select addr,xidusn,xidslot,xidsqn from v$transaction;</p>
<p>ADDR            XIDUSN      XIDSLOT     XIDSQN<br />
--------              ----------   ----------            ----------<br />
6C27349C          6          5                     2958<br />
6C278F2C          4          8                    14821<br />
6C2A1314          5         36                    3361</p>
<p> </p>
<p>事务开启，新插入的数据依然在当前研究数据块中。</p>
<p> </p>
<p> </p>
<p>SQL&gt; select id, dbms_rowid.rowid_relative_fno(rowid) fno, dbms_rowid.rowid_block_number(rowid) bno, dbms_rowid.rowid_row_number(rowid) row_num from t2;</p>
<p> </p>
<p>       ID       FNO       BNO   ROW_NUM</p>
<p>---------- ---------- ---------- ----------</p>
<p>        1         1     65266         0</p>
<p>        2         1     65266         1</p>
<p>        3         1     65266         2</p>
<p> </p>
<p> </p>
<p>事务槽dump结果。</p>
<p> </p>
<p> </p>
<p> Itl          Xid                 Uba        Flag Lck       Scn/Fsc</p>
<p>0x01  0x0003.017.000085eb 0x008005d6.351e.11 ----   1 fsc 0x0002.00000000</p>
<p>0x02  0x0009.019.000085e2 0x00800c4e.306a.2c ----   1 fsc 0x0000.00000000</p>
<p>0x03  0x0002.008.000085fe 0x00800166.3192.0b ----   1 fsc 0x0000.00000000</p>
<p> </p>
<p> </p>
<p>当当前准备的事务槽个数小于数据块进行的事务个数时，会进行事务槽自动拓展。</p>
<p> </p>
<p><strong>6、事务清理</strong></p>
<p> </p>
<p>当事务结束，事务槽清理。</p>
<p>SQL&gt; alter system dump datafile 4 block 566;</p>
<p>System altered</p>
<p> </p>
<p> Itl          Xid                 Uba        Flag Lck       Scn/Fsc</p>
<p>0x01  0x0007.02a.000085d4 0x00800ca8.35fc.09 C---   0 scn 0x078c.7f2ddad3</p>
<p>0x02  0x0000.000.00000000 0x00000000.0000.00 ----   0 fsc 0x0000.00000000</p>
<p>0x03  0x0000.000.00000000 0x00000000.0000.00 ----   0 fsc 0x0000.00000000</p>
<p><strong>7、结论</strong></p>
<p>在Oracle数据块上，ITL是一个重要的部分。它与会话、事务、多版本一致度等特性密切相关</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-04 22:55:14</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/oracle/" title="oracle">oracle</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/file/" title="file">file</a>, <a href="https://www.iamivan.net/tag/thread/" title="thread">thread</a>, <a href="https://www.iamivan.net/tag/transaction/" title="Transaction">Transaction</a>, <a href="https://www.iamivan.net/tag/dump/" title="dump">dump</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>dump命令1——ITL文件dump的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGrkK3p.html" rel="bookmark">WinDBG 技巧：如何生成Dump 文件&lpar;&period;dump 命令&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序崩溃(crash)的时候, 为了以后能够调试分析问题, 可以使用WinDBG要把当时程序内存空间数据都保存下来,生成的文件称为dump 文件. 步骤: 1) 打开WinDBG并将之Attach 到crash的程序进程 2) 输入产生dump 文件的命令 WinDBG产生dump 文件的命令是 .dump ,可以选择不同的参数来生成不同类型的dump文件. 选项(1): /m 命令行示例:.dump /m C:\dumps\myapp.dmp 注解: 缺省选项,生成标准的minidump, 转			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8NBRob.html" rel="bookmark">Oracle常用dump命令，记录一下备查。&lowbar;oracle</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Memory Dumps 1).Global Area ALTER SESSION SET EVENTS 'immediate trace name global_area level n'; 1 包含PGA 2 包含SGA 4 包含UGA 8 包含indrect memory 2).Library Cache ALTER SESSION SET EVENTS 'immediate trace name library_cache level n'; 1 library cache统计信息			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1j5lop.html" rel="bookmark">ZT&colon;Oracle常用dump命令</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://ningoo.itpub.net/post/2149/287794 Oracle常用dump命令,记录一下备查. 一.Memory Dumps 1).Global Area ALTER SESSION SET EVENTS 'immediate trace name global_area level n'; 1 包含PGA2 包含SGA4 包含UGA8 包含indrect memory 2).Library Cache ALTER SESSION SET EVENTS 'imme			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M60GDAz.html" rel="bookmark">如何分析解读systemstat dump产生的trc文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    ORACLE数据库的systemstat dump生成trace文件虽然比较简单,但是怎么从trace文件中浩如烟海的信息中提炼有用信息,并作出分析诊断是一件技术活,下面收集.整理如何分析解读systemstat dump产生的trace文件.     如果要人工去解读systemstat dump生成的trace文件,真是一件体力活,因为这些trace文件动不动就几百M甚至更大,它产生的跟踪文件包含了系统中所有进程的进程状态等信 息.每个进程对应跟踪文件中的一段内容,反映该进程的状态信			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baK4kPp.html" rel="bookmark">Linux命令大全备份压缩&colon; dump</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				功能说明:备份文件系统. 语 法:dump&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;[-cnu][-0123456789][-b &lt;区块大小&gt;][-B &lt;区块数目&gt;][-d &lt;密度&gt;][-f &lt;设备名称&gt;][-h &lt;层级&gt;][-s &lt;磁带长度&gt;][-T &lt;日期&gt;][目录或文件系统] 或 dump [-wW] 补充说明:dump			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjLw98p.html" rel="bookmark">数据库内核月报 － 2015 &sol; 08-PgSQL &CenterDot; 答疑解惑 &CenterDot; 归档进程cp命令的core文件追查</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题现象 最近我们的几个非生产实例中,均出现了由archiver进程产生的core dump文件,让人如临大敌:是不是遇到了PG的大BUG导致了crash? 先来看看这些core文件.由于我们在/proc/sys/kernel/core_pattern指定了存放core文件的目录,所以可以在这个目录里面找到这些core文件.幸运的是,这些core文件都不大,一般几百KB,没有对文件系统的存储空间造成压力: $du -sh * 248K core.170254 248K core.242719 2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOwl9vz.html" rel="bookmark">用Net命令使局域网文件批量同步更新</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现在大家都希望有个同步软件可以达到网络目录或者文件的更新来减少自己的工作量,现在网络上也有很多软件可以达到这个目的,象同步专家之类的,但是这些软件需要安装服务端和客户端,客户端要常驻才能使用,并且占用了一定的资源. 如下这个批处理利用net命令来进行文件和目录的同步更新.优点就是任何机器都可以做服务器和客户机,而且不占用任何资源.当然缺点也有就是写批处理有点烦^^. 我首先写出批处理,然后作详细的解释: net use S: computer-01D attrib -s -h -r S:ghos			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr37mWp.html" rel="bookmark">Win7操作系统使用CMD命令强行删除文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  Win7操作系统使用CMD命令强行删除文件         具体步骤如下: 1.在搜索框中输入cmd-回车; 2.在弹出的黑色运行窗口里面输入图的:del /? ---&gt;然后敲回车按键; 3.只要在DOS窗口中输入上面的命令就行了; 2.根据帮助信息得到命令使用方法便是:del [参数] [路径文件夹或目的文件] 例如: 我要删除c盘下面的&quot;TimeEventNSIS.log&quot;文件 这条命令便写成:del C:TimeEventNSIS.log 如果是强制删除则写成:del			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDYm4Kb.html" rel="bookmark">ftp的dir或ls命令无法查看文件列表怎么办</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  网友们可能在使用ftp的dir或ls命令时查看文件列表,但是却无法看到,受到了限制,那么无法查看文件列表这就造成了我们许多的麻烦,那么要怎么的解决这个问题呢!现在我们一起来看看吧! 在Win7系统的命令行模式下,使用ftp的dir或ls命令无法查看文件列表,但是使用IE却可以查看.查找相关资料后,大致归结为两种原因: 权限有问题 windows自带防火墙拦截 实验后发现我的情况属于第二种,具体解决方法有以下几种: 直接关闭Windows防火墙 打开防火墙,但是设置入站规则允许ftp.exe程			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boOJgb.html" rel="bookmark" class="title">Linux下简单限制网卡带宽的设置方法</a>
					<div>
						  1.安装iproute 代码如下: yum -y install iproute 2.限制eth0网卡的带宽为50kbit 代码如下: /sbin/tc qdisc add dev eth0 ro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDB4vM.html" rel="bookmark" class="title">Webjx收集45个设计鲜亮的精美网站</a>
					<div>
						1. Eurovision Song Contest – Helsinki 2007 2. – VG DESIGN - 3. Internet Dreams web site design 4. 13 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJ5D4p.html" rel="bookmark" class="title">论析搜索引擎：网站建设如何跃然居上</a>
					<div>
						在互联网这个平台一些人是为了创业生存着,一些人是公司企业打品牌.但是创业就要闯出去,打品牌就要真正的打出去,很多网站建设个一年两年也是种维持在&quot;半死不活&quot;的状态.面对这样一个始终没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlEeNp.html" rel="bookmark" class="title">如何设置屏幕分辨率、颜色位数、刷新率</a>
					<div>
						分辨率|刷新 '////////////////////////////////'//'//griefforyou收集整理'//'////////////////////////////////Pri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVgaKb.html" rel="bookmark" class="title">潜在的错误</a>
					<div>
						错误 错误:    SqlParameter parameterUserID = new SqlParameter(&quot;@userID&quot;, SqlDbType.Int);parame ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2BZVp.html" rel="bookmark" class="title">java的算术运算符</a>
					<div>
						Java的基本算术运算符与其他大多数程序设计语言是相同的.其中包括加号(+).减号(-).除号(/).乘号(*)以及模数(%,从整数除法中获得余数).整数除法会直接砍掉小数,而不是进位. Java也用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91g7dM.html" rel="bookmark" class="title">Win7系统登陆用户头像图标的方法</a>
					<div>
						  步骤/方法 1.在桌面直接用鼠标右键单击,选择&quot;个性化&quot;. 2.然后在左边,选择&quot;更改账户图片&quot;. 3.然后选中一张喜欢的图片,点击右下角的&quot;更改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLxyOb.html" rel="bookmark" class="title">Win7系统关闭搜狗输入法表情功能的方法</a>
					<div>
						  Win7系统关闭搜狗输入法表情功能的方法 1.打开搜狗输入法,点出&quot;属性&quot;窗口,最简单的办法是右击输入法横条,选择&quot;设置属性&quot;; 2.在弹出的属性设置的窗口 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AjAap.html" rel="bookmark" class="title">word安全模式是什么？</a>
					<div>
						  word安全模式是什么? word打不开,显示上面的对话框,在点击了&quot;不发送&quot;按钮后将关闭.再次运行 Word,将询问是否以安全模式启动 Word.在此如果选择&quot;是& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24RKZp.html" rel="bookmark" class="title">Win8&period;1软件兼容性问题解决方法</a>
					<div>
						  Win8.1是很好用,但是很多朋友担心Win7的软件无法跑在Win8.1上面,因此对装新系统望而却步,其实微软还是考虑的很周到的,除了通过统一的API,让大部分Win7软件能够顺利在Win8.1上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAr6V3p.html" rel="bookmark" class="title">Excel瞬间识别相同值</a>
					<div>
						  还在盯着屏幕找茬咩?其实Excel可以迅速直接地帮助你筛选哦!在&quot;样式&quot;中选择&quot;条件格式&quot;中的&quot;新建规则&quot;&gt;选择&quot;仅对唯 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7JqEb.html" rel="bookmark" class="title">Win7系统CPU占用率高如何解决？</a>
					<div>
						  1.打开任务管理器,关闭一些占用CPU较高的进程,但是不要关闭System Idle Process这个进程,这个进程是系统管理的进程,另外有很多个svchost.exe,这些进程也不要随便关闭, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdD0kM.html" rel="bookmark" class="title">迅雷高速通道进入失败&lpar;包括获取流量失败、进入超时&rpar;</a>
					<div>
						1. 核实&quot;个别资源&quot;还是&quot;全部资源&quot;高速通道进入失败. ① 登录http://dl.xunlei.com下载迅雷7软件安装包,测试下载,核实下是否个别资源进入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa0amM.html" rel="bookmark" class="title">启动易超级U盘制作工具操作教程</a>
					<div>
						二.操作篇: 点击启动易图标,进入程序界面,请关注&quot;提示&quot; 如上图所示,启动易的U盘启动制作步骤,高效.简单.容易. 启动易采用双模式应用:USB-HDD和USB-ZIP.(推荐使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZd3wqM.html" rel="bookmark" class="title">泛函编程（18）－泛函库设计－并行运算组件库</a>
					<div>
						   作为专业的编程人员,我们经常会因为工作需要建立一些工具库.所谓工具库就是针对工作上经常会遇到的一些共性问题预先编制的由一整套函数所组成的函数库.通常这些工具库的功能都是在特别定制的一些数据类型支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ojKAb.html" rel="bookmark" class="title">有关log4j的一些知识</a>
					<div>
						一.log4j使用     一般情况下Log4j总是和Apache Commons-logging配套使用,XXX是引入log对象的实例类名. import org.apache.commons.lo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXj39vb.html" rel="bookmark" class="title">关于whois查询的问题，为了得到域名的一些信息。</a>
					<div>
						问题描述 关于whois查询的问题,为了得到域名的一些信息. whois查询首先先要与whois.apnic.net建立TCP连接,然后再需要向服务器发送什么指令呢?是某个域名,还是某个域名对应的IP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NNByM.html" rel="bookmark" class="title">服务器-关于转发和重定向，有大神可以给详细的说下区别么？</a>
					<div>
						问题描述 关于转发和重定向,有大神可以给详细的说下区别么? 重定向就是在服务器端,先返回到浏览器端,然后才可以重定向到服务器端. 转发是在服务器端直接可以跳转到服务器端的另一个界面,. 有人可以详细说 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEDN4z.html" rel="bookmark" class="title">移动4G取消长途漫游费 用户可自由组合流量、通话、短信数</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 中移动4G资费方案最大的变化在于取消了长途漫游 本报记者 刘方远 北京报道 随着中国移动版iPhone的开售,人们对于4G网络的关注也达到了高峰.事实上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDqEKz.html" rel="bookmark" class="title">传域名服务商GoDaddy将收购欧洲竞争对手 开拓网站主机业务</a>
					<div>
						北京时间11月25日早间消息,路透社援引消息人士的说法称,美国域名注册服务商GoDaddy正展开排他性谈判,收购同行业公司Host Europe Group(HEG).该公司正寻求开拓除网站建设以外的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXAYmz.html" rel="bookmark" class="title">Ubuntu Shell编程基础入门</a>
					<div>
						我们可以使用任意一种http://www.aliyun.com/zixun/aggregation/18452.html&quot;&gt;文字编辑器,比如gedit.kedit.emacs.vi等来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBVj0M.html" rel="bookmark" class="title">datagridview-在c&num;的dataGridView怎么复制某行某列文字</a>
					<div>
						问题描述 在c#的dataGridView怎么复制某行某列文字 如图中,我希望在按保存时候检测是否存在帐号相同的人如果有,就弹出窗口说存在帐号相同的人,请重新检查,如果没有就可以把数据保存到数据库中. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEROoM.html" rel="bookmark" class="title">为什么要学习和使用 C 语言？</a>
					<div>
						一.前言 对于理工 科学生来说,这个答案可能很简单,因为这是一门必修课.而对于程序员来说选择一门编程语言,在某种程度上,对职业生涯的发展会产生重大的影响,所以必须慎 之又慎.那么,为什么要选择一门诞生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo0PwM.html" rel="bookmark" class="title">云应用与云人才</a>
					<div>
						栏目寄语: 云计算的已经为我们打开了大门.加强云技术,添加云应用,彰显云价值,&lt;中国计算机报&gt;与微软(中国)有限公司联合举办了Windows Server 云创益大赛,历时5个多月,共吸引 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RQa7z.html" rel="bookmark" class="title">优雅的开发Swift和Objective-C混编的Framework</a>
					<div>
						前言 为什么要写这样一篇文章,因为昨天和一个朋友讨论到Swift和Objective C如何混合开发Framework,中途发现了很多有意思的坑. 用Swift封装OC的库是一件比较常见的事情,毕竟对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7Ox3z.html" rel="bookmark" class="title">ios-iOS有没有类似于Android中singleTask的界面跳转机制？</a>
					<div>
						问题描述 iOS有没有类似于Android中singleTask的界面跳转机制? 就是从界面A跳转到B,然后返回界面A,再跳转到B,而不是重新生成一个B'.用storyboard和不用storyboa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK594Lp.html" rel="bookmark" class="title">香港科技大学杨强教授：AI学术的前沿工作，也要从工业界获得灵感｜CCF－GAIR 2017</a>
					<div>
						雷锋网(公众号:雷锋网) AI 科技评论按:在7月7日,由中国计算机学会(CCF)主办,雷锋网与香港中文大学(深圳)承办的第二届 CCF-GAIR全球人工智能与机器人峰会正式召开.今年CCF-GAIR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7Exez.html" rel="bookmark" class="title">快钱公司与赌博集团勾结遭通报</a>
					<div>
						据有相关人士称,第三方支付平台&quot;快钱&quot;公司,最近因为为赌博网站提供了支付服务,从中获利1700余万的暴力,而遭到公安部的通报. 据公安部官方网站的通报,在江苏苏州侦破的&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwvA1M.html" rel="bookmark" class="title">MYSQL日常操作命令再熟悉</a>
					<div>
						1,创建用户及密码: CREATE USER 'user'@'%' IDENTIFIED BY 'password';   2,创建数据库: create database PDB_chengang  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwlxOM.html" rel="bookmark" class="title">路由器-外网访问不了自已搭的网站</a>
					<div>
						问题描述 外网访问不了自已搭的网站 我的内网ip: 我用内网访问我的网站: 我的外网ip: 测试外网连接性: 路由器映射: 用外网访问网站: 为什么访问不了呢? 解决方案 检查你的计算机的防火墙配置, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.040 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
